{***************************************************************************}
{                            UNIDAD DE PINTURA 1

                                  Copyright (c) 1998 Marco Antonio Alvarado

Utiliza el modo $13 320 * 200, 256 colores de BIOS, VGA.

ADVERTENCIA

* Evite usar esta unidad junto con la Unidad de Pintura 2.}
{***************************************************************************}

UNIT UPintur1;

INTERFACE

  USES
    UVGA;  {Unidad de Video Graphic Array}

  TYPE

    RFiltro = RECORD
      Coeficientes : ARRAY [0..24] OF Integer;
      Factor : Integer;
      Incremento : Integer;
    END;

    RPunto2 = RECORD
      X,
      Y : Integer;
    END;

    RPunto3 = RECORD
      X,
      Y,
      Z : Integer;
    END;

    RCuadro = RECORD
      Pintura : Pointer;
      Ancho,
      Alto : Word;
    END;

  CONST

    FiltroBorrosidad : RFiltro =
      (Coeficientes :
        (1, 1, 1, 1, 1,
         1, 1, 1, 1, 1,
         1, 1, 1, 1, 1,
         1, 1, 1, 1, 1,
         1, 1, 1, 1, 1);
       Factor : 25;
       Incremento : 0);

    FiltroSuavidad : RFiltro =
      (Coeficientes :
        (0, 0, 0, 0, 0,
         0, 1, 3, 1, 0,
         0, 3, 5, 3, 0,
         0, 1, 3, 1, 0,
         0, 0, 0, 0, 0);
       Factor : 21;
       Incremento : 0);

    FiltroMareo : RFiltro =
      (Coeficientes :
        (1, 0, 0, 0, 0,
         1, 0, 0, 0, 0,
         0, 0, 1, 0, 0,
         0, 0, 0, 0, 1,
         0, 0, 0, 0, 1);
       Factor : 5;
       Incremento : 0);

    FiltroExpansion : RFiltro =
      (Coeficientes :
        (1, 0, 0, 0, 1,
         0, 0, 0, 0, 0,
         0, 0, 0, 0, 0,
         0, 0, 0, 0, 0,
         1, 0, 0, 0, 1);
       Factor : 4;
       Incremento : 0);

    FiltroMosaico : RFiltro =
      (Coeficientes :
        (1, 0, 1, 0, 1,
         0, 0, 0, 0, 0,
         1, 0, 0, 0, 1,
         0, 0, 0, 0, 0,
         1, 0, 1, 0, 1);
       Factor : 8;
       Incremento : 0);

    FiltroProyeccion : RFiltro =
      (Coeficientes :
        (1, 0, 0, 0, 0,
         0, 1, 0, 0, 0,
         0, 0, 1, 0, 0,
         0, 0, 1, 0, 0,
         0, 0, 1, 0, 0);
       Factor : 5;
       Incremento : 0);

    FiltroFuego : RFiltro =
      (Coeficientes :
        (0, 0, 0, 0, 0,
         0, 0, 0, 0, 0,
         0, 0, 1, 0, 0,
         0, 1, 1, 1, 0,
         0, 0, 0, 0, 0);
       Factor : 4;
       Incremento : 0);

  VAR
    Fundicion : Pointer;
    MasX1Simbolo,
    MasY1Simbolo,
    MasX2Simbolo,
    MasY2Simbolo,
    MasX3Simbolo,
    MasY3Simbolo : Integer;

    Filtro : RFiltro;

  PROCEDURE TomaPlantilla (VAR X1, Y1, X2, Y2 : Integer);
  PROCEDURE PonePlantilla (X1, Y1, X2, Y2 : Integer);
  PROCEDURE MuevePlantilla (MasX, MasY : Integer);
  PROCEDURE CrecePlantilla (MasX, MasY : Integer);
  FUNCTION PuntoDentroPlantilla (X, Y : Integer) : Boolean;
  FUNCTION CajaDentroPlantilla (X1, Y1, X2, Y2 : Integer) : Boolean;
  FUNCTION CuadroDentroPlantilla (X, Y : Integer; Ancho, Alto : Word) :
    Boolean;

{***************************************************************************}

  FUNCTION CopiaPunto (X, Y : Integer) : Byte;
  PROCEDURE PegaPunto (Color : Byte; X, Y : Integer);
  PROCEDURE PegaLinea (Color : Byte; X1, Y1, X2, Y2 : Integer);
  PROCEDURE PegaLineas (Color : Byte; Puntos : ARRAY OF RPunto2; Lineas :
    Word);
  PROCEDURE PegaCurva (Color, X1, Y1, X2, Y2, X3, Y3 : Integer);
  PROCEDURE PegaCurvas (Color : Byte; Puntos : ARRAY OF RPunto2; Curvas :
    Word);
  PROCEDURE PegaCaja (Color : Byte; X1, Y1, X2, Y2 : Integer);
  PROCEDURE PegaCajaLlena (Color : Byte; X1, Y1, X2, Y2 : Integer);
  PROCEDURE PegaRueda (Color : Byte; X, Y : Integer; RadioX, RadioY : Word);
  PROCEDURE PegaRuedaLlena (Color : Byte; X, Y : Integer; RadioX, RadioY :
    Word);

{***************************************************************************}

  PROCEDURE ExpandeSimbolo (PorX, PorY : Integer);
  PROCEDURE PegaSimbolos (Color : Byte; Simbolos : STRING; X, Y : Integer);

{***************************************************************************}

  PROCEDURE CopiaCuadro (X, Y : Integer; Hacia : Pointer; Ancho, Alto :
    Word);
  PROCEDURE PegaCuadro (Desde : Pointer; Ancho, Alto : Word; X, Y : Integer);
  PROCEDURE PegaCuadroHueco (Desde : Pointer; Ancho, Alto : Word; X, Y :
    Integer; Color : Byte);
  PROCEDURE PegaCuadroSolo (Desde : Pointer; Ancho, Alto : Word; X, Y :
    Integer; Color : Byte);

{***************************************************************************}

  PROCEDURE FiltraPunto (X, Y : Integer);
  PROCEDURE FiltraLinea (X1, Y1, X2, Y2 : Integer);
  PROCEDURE FiltraLineas (Puntos : ARRAY OF RPunto2; Lineas : Word);
  PROCEDURE FiltraCurva (X1, Y1, X2, Y2, X3, Y3 : Integer);
  PROCEDURE FiltraCurvas (Puntos : ARRAY OF RPunto2; Curvas : Word);
  PROCEDURE FiltraCaja (X1, Y1, X2, Y2 : Integer);
  PROCEDURE FiltraCajaLlena (X1, Y1, X2, Y2 : Integer);
  PROCEDURE FiltraRueda (X, Y : Integer; RadioX, RadioY : Word);
  PROCEDURE FiltraRuedaLlena (X, Y : Integer; RadioX, RadioY : Word);
  PROCEDURE FiltraSimbolos (Simbolos : STRING; X, Y : Integer);
  PROCEDURE FiltraCuadro (X, Y : Integer; Ancho, Alto : Word);

{***************************************************************************}

  PROCEDURE AcercaColor (Color : Byte; Hasta : RMezcla3; Cantidad : Byte);

IMPLEMENTATION

  USES
    UVBS,  {Unidad de Video BIOS Services}
    UMemoria;  {Unidad de Memoria}

  VAR
    X1Plantilla,
    Y1Plantilla,
    X2Plantilla,
    Y2Plantilla : Integer;
    AnchoPlantilla,
    AltoPlantilla : Word;

  PROCEDURE TomaPlantilla (VAR X1, Y1, X2, Y2 : Integer);
  BEGIN
    X1 := X1Plantilla;
    Y1 := Y1Plantilla;
    X2 := X2Plantilla;
    Y2 := Y2Plantilla;
  END;

  PROCEDURE AjustaPlantilla;
  BEGIN
    IF X1Plantilla > X2Plantilla THEN Intercambia (X1Plantilla, X2Plantilla);
    IF Y1Plantilla > Y2Plantilla THEN Intercambia (Y1Plantilla, Y2Plantilla);
    IF X1Plantilla < X1Pantalla THEN X1Plantilla := X1Pantalla;
    IF Y1Plantilla < Y1Pantalla THEN Y1Plantilla := Y1Pantalla;
    IF X2Plantilla > X2Pantalla THEN X2Plantilla := X2Pantalla;
    IF Y2Plantilla > Y2Pantalla THEN Y2Plantilla := Y2Pantalla;
    AnchoPlantilla := X2Plantilla - X1Plantilla + 1;
    AltoPlantilla := Y2Plantilla - Y1Plantilla + 1;
  END;

  PROCEDURE PonePlantilla (X1, Y1, X2, Y2 : Integer);
  BEGIN
{Suma.}
    X1Plantilla := X1;
    Y1Plantilla := Y1;
    X2Plantilla := X2;
    Y2Plantilla := Y2;

{Ajusta.}
    AjustaPlantilla;
  END;

  PROCEDURE MuevePlantilla (MasX, MasY : Integer);
  BEGIN
{Mueve.}
    Inc (X1Plantilla, MasX);
    Inc (Y1Plantilla, MasY);
    Inc (X2Plantilla, MasX);
    Inc (Y2Plantilla, MasY);

{Ajusta.}
    AjustaPlantilla;
  END;

  PROCEDURE CrecePlantilla (MasX, MasY : Integer);
  BEGIN
{Crece.}
    Dec (X1Plantilla, MasX);
    Dec (Y1Plantilla, MasY);
    Inc (X2Plantilla, MasX);
    Inc (Y2Plantilla, MasY);

{Ajusta.}
    AjustaPlantilla;
  END;

  FUNCTION PuntoDentroPlantilla (X, Y : Integer) : Boolean;
  BEGIN
    PuntoDentroPlantilla := (X >= X1Plantilla) AND (Y >= Y1Plantilla) AND
      (X <= X2Plantilla) AND (Y <= Y2Plantilla);
  END;

  FUNCTION CajaDentroPlantilla (X1, Y1, X2, Y2 : Integer) : Boolean;
  BEGIN
{Ajusta.}
    IF X1 > X2 THEN Intercambia (X1, X2);
    IF Y1 > Y2 THEN Intercambia (Y1, Y2);

{Regresa true SI toda la Caja o parte de ella est Dentro de la Plantilla.}
    CajaDentroPlantilla := (X1 <= X2Plantilla) AND (Y1 <= Y2Plantilla) AND
      (X2 >= X1Plantilla) AND (Y2 >= Y1Plantilla);
  END;

  FUNCTION CuadroDentroPlantilla (X, Y : Integer; Ancho, Alto : Word) :
    Boolean;
  BEGIN
{Regresa true SI todo el Cuadro o parte de l est Dentro de la Plantilla.}
    CuadroDentroPlantilla := (X <= X2Plantilla) AND (Y <= Y2Plantilla) AND
      (X + Ancho > X1Plantilla) AND (Y + Alto > Y1Plantilla);
  END;

{***************************************************************************}

  FUNCTION CopiaPunto (X, Y : Integer) : Byte;
  BEGIN
    IF PuntoDentroPlantilla (X, Y) THEN
      CopiaPunto := UVGA. CopiaPuntoPrevia (Word (Y) * AnchoPantalla + X)
    ELSE
      CopiaPunto := 0;
  END;

  PROCEDURE PegaPunto (Color : Byte; X, Y : Integer);
  BEGIN
    IF PuntoDentroPlantilla (X, Y) THEN
      UVGA. PegaPuntoPrevia (Color, Word (Y) * AnchoPantalla + X);
  END;

{Basada en la rutina de Menno Victor van der star}
  PROCEDURE PegaLinea (Color : Byte; X1, Y1, X2, Y2 : Integer);

    VAR
      D,
      AX,
      AY,
      SX,
      SY,
      DX,
      DY : Integer;

  BEGIN
    DX := X2 - X1;
    AX := Abs (DX) SHL 1;
    IF DX < 0 THEN SX := -1 ELSE SX := 1;
    DY := Y2 - Y1;
    AY := Abs (DY) SHL 1;
    IF DY < 0 THEN SY := -1 ELSE SY := 1;
    PegaPunto (Color, X1, Y1);

    IF AX > AY THEN
    BEGIN
      D := AY - (AX SHR 1);

      WHILE X1 <> X2 DO
      BEGIN

        IF D >= 0 THEN
        BEGIN
          Inc (Y1, SY);
          Dec (D, AX);
        END;

        Inc (X1, SX);
        Inc (D, AY);
        PegaPunto (Color, X1, Y1);
      END;

    END ELSE
    BEGIN
      D := AX - (AY SHR 1);

      WHILE Y1 <> Y2 DO
      BEGIN

        IF D >= 0 THEN
        BEGIN
          Inc (X1, SX);
          Dec (D, AY);
        END;

        Inc (Y1, SY);
        Inc (D, AX);
        PegaPunto (Color, X1, Y1);
      END;

    END;

  END;

  PROCEDURE PegaLineas (Color : Byte; Puntos : ARRAY OF RPunto2; Lineas :
    Word);

    VAR
      Indice : Word;

  BEGIN
    Indice := 0;

    FOR Lineas := Lineas DOWNTO 1 DO
    BEGIN
      PegaLinea (Color, Puntos [Indice]. X, Puntos [Indice]. Y,
        Puntos [Indice + 1]. X, Puntos [Indice + 1]. Y);
      Inc (Indice);
    END;

  END;

{Basada en la rutina de Wil Barath}
  PROCEDURE PegaCurva (Color, X1, Y1, X2, Y2, X3, Y3 : Integer);

    VAR
      SX,
      SY,
      DX1,
      DX2,
      DY1,
      DY2,
      SDX,
      SDY,
      L : LongInt;
      Deep,
      Deep2,
      OX,
      OY : Integer;

  BEGIN
    DX1 := (X2 - X1);
    DX2 := (X3 - X2);
    DY1 := (Y2 - Y1);
    DY2 := (Y3 - Y2);
    Deep := 32;
    Deep2 := Deep * Deep;
    SDX := DX1 * pred (Deep * 2) - DX2;
    SDY := DY1 * pred (Deep * 2) - DY2;
    Inc (DX1, DX1);
    Inc (DX2, DX2);
    Inc (DY1, DY1);
    Inc (DY2, DY2);
    SX := 0;
    SY := 0;
    X2 := X1;
    Y2 := Y1;

    FOR L := 0 TO Deep DO
    BEGIN
      OX := X2;
      OY := Y2;
      X2 := X1 + SX DIV Deep2;
      Y2 := Y1 + SY DIV Deep2;
      PegaLinea (Color, X2, Y2, OX, OY);
      Inc (SX, SDX);
      Inc (SY, SDY);
      Inc (SDX, DX2 - DX1);
      Inc (SDY, DY2 - DY1);
    END;

    PegaLinea (Color, X2, Y2, X3, Y3);
  END;

  PROCEDURE PegaCurvas (Color : Byte; Puntos : ARRAY OF RPunto2; Curvas :
    Word);

    VAR
      Indice : Word;

  BEGIN
    Indice := 0;

    FOR Curvas := Curvas DOWNTO 1 DO
    BEGIN
      PegaCurva (Color, Puntos [Indice]. X, Puntos [Indice]. Y,
        Puntos [Indice + 1]. X, Puntos [Indice + 1]. Y,
        Puntos [Indice + 2]. X, Puntos [Indice + 2]. Y);
      Inc (Indice, 2);
    END;

  END;

  PROCEDURE PegaCaja (Color : Byte; X1, Y1, X2, Y2 : Integer);
  BEGIN
    PegaLinea (Color, X1, Y1, X2, Y1);
    PegaLinea (Color, X2, Y1, X2, Y2);
    PegaLinea (Color, X2, Y2, X1, Y2);
    PegaLinea (Color, X1, Y2, X1, Y1);
  END;

  PROCEDURE PegaCajaLlena (Color : Byte; X1, Y1, X2, Y2 : Integer);

    VAR
      Punto,
      Ancho : Word;

  BEGIN

    IF CuadroDentroPlantilla (X1, Y1, X2, Y2) THEN
    BEGIN

{Ajusta.}
      IF X1 > X2 THEN Intercambia (X1, X2);
      IF Y1 > Y2 THEN Intercambia (Y1, Y2);
      IF X1 < X1Plantilla THEN X1 := X1Plantilla;
      IF Y1 < Y1Plantilla THEN Y1 := Y1Plantilla;
      IF X2 > X2Plantilla THEN X2 := X2Plantilla;
      IF Y2 > Y2Plantilla THEN Y2 := Y2Plantilla;

      Punto := Word (Y1) * AnchoPantalla + X1;
      Ancho := X2 - X1 + 1;

      FOR Y1 := Y1 TO Y2 DO
      BEGIN
        UVGA. LlenaPuntoPrevia (Color, Punto, Ancho);
        Inc (Punto, AnchoPantalla);
      END;

    END;

  END;

{Basada en la rutina de Gerd, correo: gerd.platl@siemens.at}
  PROCEDURE PegaRueda (Color : Byte; X, Y : Integer; RadioX, RadioY : Word);

    VAR
      Radio,
      X1,
      X2,
      Y1,
      Y2 : Integer;
      AQ,
      BQ,
      DX,
      DY,
      R,
      RX,
      RY : LongInt;

  BEGIN
    PegaPunto (Color, X + RadioX, Y);
    PegaPunto (Color, X - RadioX, Y);
    X1 := X - RadioX;
    Y1 := Y;
    X2 := X + RadioX;
    Y2 := Y;
    AQ := LongInt (RadioX) * RadioX;
    BQ := LongInt (RadioY) * RadioY;
    DX := AQ SHL 1;
    DY := BQ SHL 1;
    R := RadioX * BQ;
    RX := R SHL 1;
    RY := 0;
    Radio := RadioX;

    WHILE Radio > 0 DO
    BEGIN

      IF R > 0 THEN
      BEGIN
        Inc (Y1);
        Dec (Y2);
        Inc (RY, DX);
        Dec (R, RY);
      END;

      IF R <= 0 THEN
      BEGIN
        Dec (Radio);
        Inc (X1);
        Dec (X2);
        Dec (RX, DY);
        Inc (R, RX);
      END;

      PegaPunto (Color, X1, Y1);
      PegaPunto (Color, X1, Y2);
      PegaPunto (Color, X2, Y1);
      PegaPunto (Color, X2, Y2);
    END;

  END;

  PROCEDURE PegaRuedaLlena (Color : Byte; X, Y : Integer; RadioX, RadioY :
    Word);

    VAR
      Radio,
      X1,
      X2,
      Y1,
      Y2 : Integer;
      AQ,
      BQ,
      DX,
      DY,
      R,
      RX,
      RY : LongInt;

  BEGIN
    PegaLinea (Color, X - RadioX, Y, X + RadioX, Y);
    X1 := X - RadioX;
    Y1 := Y;
    X2 := X + RadioX;
    Y2 := Y;
    AQ := LongInt (RadioX) * RadioX;
    BQ := LongInt (RadioY) * RadioY;
    DX := AQ SHL 1;
    DY := BQ SHL 1;
    R := RadioX * BQ;
    RX := R SHL 1;
    RY := 0;
    Radio := RadioX;

    WHILE Radio > 0 DO
    BEGIN

      IF R > 0 THEN
      BEGIN
        Inc (Y1);
        Dec (Y2);
        Inc (RY, DX);
        Dec (R, RY);
      END;

      IF R <= 0 THEN
      BEGIN
        Dec (Radio);
        Inc (X1);
        Dec (X2);
        Dec (RX, DY);
        Inc (R, RX);
      END;

      PegaLinea (Color, X1, Y1, X2, Y1);
      PegaLinea (Color, X1, Y2, X2, Y2);
    END;

  END;

{***************************************************************************}

  PROCEDURE ExpandeSimbolo (PorX, PorY : Integer);
  BEGIN
    MasX1Simbolo := MasX1Simbolo * PorX;
    MasY1Simbolo := MasY1Simbolo * PorY;
    MasX2Simbolo := MasX2Simbolo * PorX;
    MasY2Simbolo := MasY2Simbolo * PorY;
    MasX3Simbolo := MasX3Simbolo * PorX;
    MasY3Simbolo := MasY3Simbolo * PorY;
  END;

  PROCEDURE PegaSimbolos (Color : Byte; Simbolos : STRING; X, Y : Integer);

    VAR
      TamanoSimbolos : Byte ABSOLUTE Simbolos;
      IndiceSimbolo,
      IndiceLinea,
      Linea : Byte;
      IndiceTabla : Pointer;

  BEGIN
    IndiceSimbolo := 1;

    WHILE IndiceSimbolo <= TamanoSimbolos DO
    BEGIN
      IndiceTabla := SumaPunteroCerca (Fundicion,
        Word (Simbolos [IndiceSimbolo]) * 8);

      FOR IndiceLinea := 0 TO 7 DO
      BEGIN
        Linea := Byte (IndiceTabla^);
        IF Linea AND 128 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 64 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 32 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 16 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 8 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 4 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 2 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 1 <> 0 THEN PegaPunto (Color, X, Y);
        Inc (X, MasX2Simbolo);
        Inc (Y, MasY2Simbolo);
        Inc (Word (IndiceTabla));
      END;

      Inc (X, MasX3Simbolo);
      Inc (Y, MasY3Simbolo);
      Inc (IndiceSimbolo);
    END;

  END;

{***************************************************************************}

  PROCEDURE CopiaCuadro (X, Y : Integer; Hacia : Pointer; Ancho, Alto :
    Word);

    VAR
      Incremento,
      Ancho1,
      Alto1,
      Punto : Word;

  BEGIN

    IF CuadroDentroPlantilla (X, Y, Ancho, Alto) THEN
    BEGIN

{Corta los lados que estn fuera de la Plantilla.}
      IF X >= X1Plantilla THEN
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la derecha. Reduce el Ancho a la distancia entre X Y X2Plantilla.}
          Ancho1 := X2Plantilla - X + 1;
        END ELSE
        BEGIN
{No corta. Mantiene el Ancho.}
          Ancho1 := Ancho;
        END;

      END ELSE
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la iZquierda Y a la derecha.}
          Ancho1 := AnchoPlantilla;
        END ELSE
        BEGIN
{Corta a la iZquierda.}
          Ancho1 := Ancho - (X1Plantilla - X);
        END;

        Hacia := SumaPunteroCerca (Hacia, X1Plantilla - X);
        X := X1Plantilla;
      END;

      IF Y >= Y1Plantilla THEN
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta abajo.}
          Alto1 := Y2Plantilla - Y + 1;
        END ELSE
        BEGIN
{No corta.}
          Alto1 := Alto;
        END;

      END ELSE
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta arriba Y abajo.}
          Alto1 := AltoPlantilla;
        END ELSE
        BEGIN
{Corta arriba.}
          Alto1 := Alto - (Y1Plantilla - Y);
        END;

        Incremento := Word (Y1Plantilla - Y) * Ancho;
        Hacia := SumaPunteroLejos (Hacia, Incremento DIV 16,
          Incremento MOD 16);
        Y := Y1Plantilla;
      END;

      Punto := Word (Y) * AnchoPantalla + X;

      FOR Alto1 := Alto1 DOWNTO 1 DO
      BEGIN
        UVGA. CopiaPinturaPrevia (Punto, Hacia, Ancho1);
        Inc (Punto, AnchoPantalla);
        Hacia := SumaPunteroCerca (Hacia, Ancho);
      END;

    END;

  END;

  PROCEDURE PegaCuadro (Desde : Pointer; Ancho, Alto : Word; X, Y : Integer);

    VAR
      Incremento,
      Ancho1,
      Alto1,
      Punto : Word;

  BEGIN

    IF CuadroDentroPlantilla (X, Y, Ancho, Alto) THEN
    BEGIN

{Corta los lados que estn fuera de la Plantilla.}
      IF X >= X1Plantilla THEN
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la derecha. Reduce el Ancho a la distancia entre X Y X2Plantilla.}
          Ancho1 := X2Plantilla - X + 1;
        END ELSE
        BEGIN
{No corta. Mantiene el Ancho.}
          Ancho1 := Ancho;
        END;

      END ELSE
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la iZquierda Y a la derecha.}
          Ancho1 := AnchoPlantilla;
        END ELSE
        BEGIN
{Corta a la iZquierda.}
          Ancho1 := Ancho - (X1Plantilla - X);
        END;

        Desde := SumaPunteroCerca (Desde, X1Plantilla - X);
        X := X1Plantilla;
      END;

      IF Y >= Y1Plantilla THEN
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta abajo.}
          Alto1 := Y2Plantilla - Y + 1;
        END ELSE
        BEGIN
{No corta.}
          Alto1 := Alto;
        END;

      END ELSE
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta arriba Y abajo.}
          Alto1 := AltoPlantilla;
        END ELSE
        BEGIN
{Corta arriba.}
          Alto1 := Alto - (Y1Plantilla - Y);
        END;

        Incremento := Word (Y1Plantilla - Y) * Ancho;
        Desde := SumaPunteroLejos (Desde, Incremento DIV 16,
          Incremento MOD 16);
        Y := Y1Plantilla;
      END;

      Punto := Word (Y) * AnchoPantalla + X;

      FOR Alto1 := Alto1 DOWNTO 1 DO
      BEGIN
        UVGA. PegaPinturaPrevia (Desde, Punto, Ancho1);
        Inc (Punto, AnchoPantalla);
        Desde := SumaPunteroCerca (Desde, Ancho);
      END;

    END;

  END;

  PROCEDURE PegaCuadroHueco (Desde : Pointer; Ancho, Alto : Word; X, Y :
    Integer; Color : Byte);

    VAR
      Incremento,
      Ancho1,
      Alto1,
      Punto : Word;

  BEGIN

    IF CuadroDentroPlantilla (X, Y, Ancho, Alto) THEN
    BEGIN

{Corta los lados que estn fuera de la Plantilla.}
      IF X >= X1Plantilla THEN
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la derecha. Reduce el Ancho a la distancia entre X Y X2Plantilla.}
          Ancho1 := X2Plantilla - X + 1;
        END ELSE
        BEGIN
{No corta. Mantiene el Ancho.}
          Ancho1 := Ancho;
        END;

      END ELSE
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la iZquierda Y a la derecha.}
          Ancho1 := AnchoPlantilla;
        END ELSE
        BEGIN
{Corta a la iZquierda.}
          Ancho1 := Ancho - (X1Plantilla - X);
        END;

        Desde := SumaPunteroCerca (Desde, X1Plantilla - X);
        X := X1Plantilla;
      END;

      IF Y >= Y1Plantilla THEN
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta abajo.}
          Alto1 := Y2Plantilla - Y + 1;
        END ELSE
        BEGIN
{No corta.}
          Alto1 := Alto;
        END;

      END ELSE
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta arriba Y abajo.}
          Alto1 := AltoPlantilla;
        END ELSE
        BEGIN
{Corta arriba.}
          Alto1 := Alto - (Y1Plantilla - Y);
        END;

        Incremento := Word (Y1Plantilla - Y) * Ancho;
        Desde := SumaPunteroLejos (Desde, Incremento DIV 16,
          Incremento MOD 16);
        Y := Y1Plantilla;
      END;

      Punto := Word (Y) * AnchoPantalla + X;

      IF Color = 0 THEN
      BEGIN

        FOR Alto1 := Alto1 DOWNTO 1 DO
        BEGIN
          UVGA. PegaPinturaHueco0Previa (Desde, Punto, Ancho1);
          Inc (Punto, AnchoPantalla);
          Desde := SumaPunteroCerca (Desde, Ancho);
        END;

      END ELSE
      BEGIN

        FOR Alto1 := Alto1 DOWNTO 1 DO
        BEGIN
          UVGA. PegaPinturaHuecoPrevia (Desde, Punto, Ancho1, Color);
          Inc (Punto, AnchoPantalla);
          Desde := SumaPunteroCerca (Desde, Ancho);
        END;

      END;

    END;

  END;

  PROCEDURE PegaCuadroSolo (Desde : Pointer; Ancho, Alto : Word; X, Y :
    Integer; Color : Byte);

    VAR
      Incremento,
      Ancho1,
      Alto1,
      Punto : Word;

  BEGIN

    IF CuadroDentroPlantilla (X, Y, Ancho, Alto) THEN
    BEGIN

{Corta los lados que estn fuera de la Plantilla.}
      IF X >= X1Plantilla THEN
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la derecha. Reduce el Ancho a la distancia entre X Y X2Plantilla.}
          Ancho1 := X2Plantilla - X + 1;
        END ELSE
        BEGIN
{No corta. Mantiene el Ancho.}
          Ancho1 := Ancho;
        END;

      END ELSE
      BEGIN

        IF X + Ancho > X2Plantilla THEN
        BEGIN
{Corta a la iZquierda Y a la derecha.}
          Ancho1 := AnchoPlantilla;
        END ELSE
        BEGIN
{Corta a la iZquierda.}
          Ancho1 := Ancho - (X1Plantilla - X);
        END;

        Desde := SumaPunteroCerca (Desde, X1Plantilla - X);
        X := X1Plantilla;
      END;

      IF Y >= Y1Plantilla THEN
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta abajo.}
          Alto1 := Y2Plantilla - Y + 1;
        END ELSE
        BEGIN
{No corta.}
          Alto1 := Alto;
        END;

      END ELSE
      BEGIN

        IF Y + Alto > Y2Plantilla THEN
        BEGIN
{Corta arriba Y abajo.}
          Alto1 := AltoPlantilla;
        END ELSE
        BEGIN
{Corta arriba.}
          Alto1 := Alto - (Y1Plantilla - Y);
        END;

        Incremento := Word (Y1Plantilla - Y) * Ancho;
        Desde := SumaPunteroLejos (Desde, Incremento DIV 16,
          Incremento MOD 16);
        Y := Y1Plantilla;
      END;

      Punto := Word (Y) * AnchoPantalla + X;

      FOR Alto1 := Alto1 DOWNTO 1 DO
      BEGIN
        UVGA. PegaPinturaSoloPrevia (Desde, Punto, Ancho1, Color);
        Inc (Punto, AnchoPantalla);
        Desde := SumaPunteroCerca (Desde, Ancho);
      END;

    END;

  END;

{***************************************************************************}

  PROCEDURE FiltraPunto (X, Y : Integer);

    VAR
      Resultado : Integer;

  BEGIN
{Multiplica los Puntos Por los Coeficientes de la Tabla Y los Suma.}
    Resultado := 0;

    Inc (Resultado, Filtro. Coeficientes [0] * CopiaPunto (X - 2, Y - 2));
    Inc (Resultado, Filtro. Coeficientes [1] * CopiaPunto (X - 1, Y - 2));
    Inc (Resultado, Filtro. Coeficientes [2] * CopiaPunto (X, Y - 2));
    Inc (Resultado, Filtro. Coeficientes [3] * CopiaPunto (X + 1, Y - 2));
    Inc (Resultado, Filtro. Coeficientes [4] * CopiaPunto (X + 2, Y - 2));

    Inc (Resultado, Filtro. Coeficientes [5] * CopiaPunto (X - 2, Y - 1));
    Inc (Resultado, Filtro. Coeficientes [6] * CopiaPunto (X - 1, Y - 1));
    Inc (Resultado, Filtro. Coeficientes [7] * CopiaPunto (X, Y - 1));
    Inc (Resultado, Filtro. Coeficientes [8] * CopiaPunto (X + 1, Y - 1));
    Inc (Resultado, Filtro. Coeficientes [9] * CopiaPunto (X + 2, Y - 1));

    Inc (Resultado, Filtro. Coeficientes [10] * CopiaPunto (X - 2, Y));
    Inc (Resultado, Filtro. Coeficientes [11] * CopiaPunto (X - 1, Y));
    Inc (Resultado, Filtro. Coeficientes [12] * CopiaPunto (X, Y));
    Inc (Resultado, Filtro. Coeficientes [13] * CopiaPunto (X + 1, Y));
    Inc (Resultado, Filtro. Coeficientes [14] * CopiaPunto (X + 2, Y));

    Inc (Resultado, Filtro. Coeficientes [15] * CopiaPunto (X - 2, Y + 1));
    Inc (Resultado, Filtro. Coeficientes [16] * CopiaPunto (X - 1, Y + 1));
    Inc (Resultado, Filtro. Coeficientes [17] * CopiaPunto (X, Y + 1));
    Inc (Resultado, Filtro. Coeficientes [18] * CopiaPunto (X + 1, Y + 1));
    Inc (Resultado, Filtro. Coeficientes [19] * CopiaPunto (X + 2, Y + 1));

    Inc (Resultado, Filtro. Coeficientes [20] * CopiaPunto (X - 2, Y + 2));
    Inc (Resultado, Filtro. Coeficientes [21] * CopiaPunto (X - 1, Y + 2));
    Inc (Resultado, Filtro. Coeficientes [22] * CopiaPunto (X, Y + 2));
    Inc (Resultado, Filtro. Coeficientes [23] * CopiaPunto (X + 1, Y + 2));
    Inc (Resultado, Filtro. Coeficientes [24] * CopiaPunto (X + 2, Y + 2));

{Divide entre el Factor.}
    Resultado := Resultado DIV Filtro. Factor;

{Suma el Incremento.}
    Inc (Resultado, Filtro. Incremento);

{Pega el Punto.}
    PegaPunto (Byte (Resultado), X, Y);
  END;

  PROCEDURE FiltraLinea (X1, Y1, X2, Y2 : Integer);

    VAR
      D,
      AX,
      AY,
      SX,
      SY,
      DX,
      DY : Integer;

  BEGIN
    DX := X2 - X1;
    AX := Abs (DX) SHL 1;
    IF DX < 0 THEN SX := -1 ELSE SX := 1;
    DY := Y2 - Y1;
    AY := Abs (DY) SHL 1;
    IF DY < 0 THEN SY := -1 ELSE SY := 1;
    FiltraPunto (X1, Y1);

    IF AX > AY THEN
    BEGIN
      D := AY - (AX SHR 1);

      WHILE X1 <> X2 DO
      BEGIN

        IF D >= 0 THEN
        BEGIN
          Inc (Y1, SY);
          Dec (D, AX);
        END;

        Inc (X1, SX);
        Inc (D, AY);
        FiltraPunto (X1, Y1);
      END;

    END ELSE
    BEGIN
      D := AX - (AY SHR 1);

      WHILE Y1 <> Y2 DO
      BEGIN

        IF D >= 0 THEN
        BEGIN
          Inc (X1, SX);
          Dec (D, AY);
        END;

        Inc (Y1, SY);
        Inc (D, AX);
        FiltraPunto (X1, Y1);
      END;

    END;

  END;

  PROCEDURE FiltraLineas (Puntos : ARRAY OF RPunto2; Lineas : Word);

    VAR
      Indice : Word;

  BEGIN
    Indice := 0;

    FOR Lineas := Lineas DOWNTO 1 DO
    BEGIN
      FiltraLinea (Puntos [Indice]. X, Puntos [Indice]. Y,
        Puntos [Indice + 1]. X, Puntos [Indice + 1]. Y);
      Inc (Indice);
    END;

  END;

  PROCEDURE FiltraCurva (X1, Y1, X2, Y2, X3, Y3 : Integer);

    VAR
      SX,
      SY,
      DX1,
      DX2,
      DY1,
      DY2,
      SDX,
      SDY,
      L : LongInt;
      Deep,
      Deep2,
      OX,
      OY : Integer;

  BEGIN
    DX1 := (X2 - X1);
    DX2 := (X3 - X2);
    DY1 := (Y2 - Y1);
    DY2 := (Y3 - Y2);
    Deep := 32;
    Deep2 := Deep * Deep;
    SDX := DX1 * pred (Deep * 2) - DX2;
    SDY := DY1 * pred (Deep * 2) - DY2;
    Inc (DX1, DX1);
    Inc (DX2, DX2);
    Inc (DY1, DY1);
    Inc (DY2, DY2);
    SX := 0;
    SY := 0;
    X2 := X1;
    Y2 := Y1;

    FOR L := 0 TO Deep DO
    BEGIN
      OX := X2;
      OY := Y2;
      X2 := X1 + SX DIV Deep2;
      Y2 := Y1 + SY DIV Deep2;
      FiltraLinea (X2, Y2, OX, OY);
      Inc (SX, SDX);
      Inc (SY, SDY);
      Inc (SDX, DX2 - DX1);
      Inc (SDY, DY2 - DY1);
    END;

    FiltraLinea (X2, Y2, X3, Y3);
  END;

  PROCEDURE FiltraCurvas (Puntos : ARRAY OF RPunto2; Curvas : Word);

    VAR
      Indice : Word;

  BEGIN
    Indice := 0;

    FOR Curvas := Curvas DOWNTO 1 DO
    BEGIN
      FiltraCurva (Puntos [Indice]. X, Puntos [Indice]. Y,
        Puntos [Indice + 1]. X, Puntos [Indice + 1]. Y,
        Puntos [Indice + 2]. X, Puntos [Indice + 2]. Y);
      Inc (Indice, 2);
    END;

  END;

  PROCEDURE FiltraCaja (X1, Y1, X2, Y2 : Integer);
  BEGIN
    FiltraLinea (X1, Y1, X2, Y1);
    FiltraLinea (X2, Y1, X2, Y2);
    FiltraLinea (X2, Y2, X1, Y2);
    FiltraLinea (X1, Y2, X1, Y1);
  END;

  PROCEDURE FiltraCajaLlena (X1, Y1, X2, Y2 : Integer);
  BEGIN

    IF Y1 <= Y2 THEN
    BEGIN
      FOR Y1 := Y1 TO Y2 DO FiltraLinea (X1, Y1, X2, Y1);
    END ELSE
    BEGIN
      FOR Y2 := Y2 TO Y1 DO FiltraLinea (X1, Y2, X2, Y2);
    END;

  END;

  PROCEDURE FiltraRueda (X, Y : Integer; RadioX, RadioY : Word);

    VAR
      Radio,
      X1,
      X2,
      Y1,
      Y2 : Integer;
      AQ,
      BQ,
      DX,
      DY,
      R,
      RX,
      RY : LongInt;

  BEGIN
    FiltraPunto (X + RadioX, Y);
    FiltraPunto (X - RadioX, Y);
    X1 := X - RadioX;
    Y1 := Y;
    X2 := X + RadioX;
    Y2 := Y;
    AQ := LongInt (RadioX) * RadioX;
    BQ := LongInt (RadioY) * RadioY;
    DX := AQ SHL 1;
    DY := BQ SHL 1;
    R := RadioX * BQ;
    RX := R SHL 1;
    RY := 0;
    Radio := RadioX;

    WHILE Radio > 0 DO
    BEGIN

      IF R > 0 THEN
      BEGIN
        Inc (Y1);
        Dec (Y2);
        Inc (RY, DX);
        Dec (R, RY);
      END;

      IF R <= 0 THEN
      BEGIN
        Dec (Radio);
        Inc (X1);
        Dec (X2);
        Dec (RX, DY);
        Inc (R, RX);
      END;

      FiltraPunto (X1, Y1);
      FiltraPunto (X1, Y2);
      FiltraPunto (X2, Y1);
      FiltraPunto (X2, Y2);
    END;

  END;

  PROCEDURE FiltraRuedaLlena (X, Y : Integer; RadioX, RadioY : Word);

    VAR
      Radio,
      X1,
      X2,
      Y1,
      Y2 : Integer;
      AQ,
      BQ,
      DX,
      DY,
      R,
      RX,
      RY : LongInt;

  BEGIN
    FiltraLinea (X - RadioX, Y, X + RadioX, Y);
    X1 := X - RadioX;
    Y1 := Y;
    X2 := X + RadioX;
    Y2 := Y;
    AQ := LongInt (RadioX) * RadioX;
    BQ := LongInt (RadioY) * RadioY;
    DX := AQ SHL 1;
    DY := BQ SHL 1;
    R := RadioX * BQ;
    RX := R SHL 1;
    RY := 0;
    Radio := RadioX;

    WHILE Radio > 0 DO
    BEGIN

      IF R > 0 THEN
      BEGIN
        Inc (Y1);
        Dec (Y2);
        Inc (RY, DX);
        Dec (R, RY);
      END;

      IF R <= 0 THEN
      BEGIN
        Dec (Radio);
        Inc (X1);
        Dec (X2);
        Dec (RX, DY);
        Inc (R, RX);
      END;

      FiltraLinea (X1, Y1, X2, Y1);
      FiltraLinea (X1, Y2, X2, Y2);
    END;

  END;

  PROCEDURE FiltraSimbolos (Simbolos : STRING; X, Y : Integer);

    VAR
      TamanoSimbolos : Byte ABSOLUTE Simbolos;
      IndiceSimbolo,
      IndiceLinea,
      Linea : Byte;
      IndiceTabla : Pointer;

  BEGIN
    IndiceSimbolo := 1;

    WHILE IndiceSimbolo <= TamanoSimbolos DO
    BEGIN
      IndiceTabla := SumaPunteroCerca (Fundicion,
        Word (Simbolos [IndiceSimbolo]) * 8);

      FOR IndiceLinea := 0 TO 7 DO
      BEGIN
        Linea := Byte (IndiceTabla^);
        IF Linea AND 128 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 64 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 32 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 16 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 8 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 4 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 2 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX1Simbolo);
        Inc (Y, MasY1Simbolo);
        IF Linea AND 1 <> 0 THEN FiltraPunto (X, Y);
        Inc (X, MasX2Simbolo);
        Inc (Y, MasY2Simbolo);
        Inc (Word (IndiceTabla));
      END;

      Inc (X, MasX3Simbolo);
      Inc (Y, MasY3Simbolo);
      Inc (IndiceSimbolo);
    END;

  END;

  PROCEDURE FiltraCuadro (X, Y : Integer; Ancho, Alto : Word);
  BEGIN
    FiltraCajaLlena (X, Y, X + Ancho, Y + Alto);
  END;

  PROCEDURE MeteFiltro;
  BEGIN
    Filtro := FiltroBorrosidad;
  END;

{***************************************************************************}

  PROCEDURE AcercaColor (Color : Byte; Hasta : RMezcla3; Cantidad : Byte);

    VAR
      Mezcla : RMezcla3;

  BEGIN
    UVGA. CopiaMezcla (Color, @Mezcla, SizeOf (Mezcla));

    FOR Cantidad := Cantidad DOWNTO 1 DO
    BEGIN
      IF Mezcla. Rojo > Hasta. Rojo THEN Dec (Mezcla. Rojo);
      IF Mezcla. Rojo < Hasta. Rojo THEN Inc (Mezcla. Rojo);
      IF Mezcla. Verde > Hasta. Verde THEN Dec (Mezcla. Verde);
      IF Mezcla. Verde < Hasta. Verde THEN Inc (Mezcla. Verde);
      IF Mezcla. Azul > Hasta. Azul THEN Dec (Mezcla. Azul);
      IF Mezcla. Azul < Hasta. Azul THEN Inc (Mezcla. Azul);
    END;

    UVGA. PegaMezcla (@Mezcla, Color, SizeOf (Mezcla));
  END;

BEGIN
{Inicia la plantilla.}
  X1Plantilla := X1Pantalla;
  Y1Plantilla := Y1Pantalla;
  X2Plantilla := X2Pantalla;
  Y2Plantilla := Y2Pantalla;
  AnchoPlantilla := AnchoPantalla;
  AltoPlantilla := AltoPantalla;

{Inicia los smbolos.}
  Fundicion := UVBS. TomaFundicion;
  MasX1Simbolo := 1;
  MasY1Simbolo := 0;
  MasX2Simbolo := -7;
  MasY2Simbolo := 1;
  MasX3Simbolo := 8;
  MasY3Simbolo := -8;

{Inicia el filtro.}
  Filtro := FiltroBorrosidad;
END.